<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Quản lý bảng điểm</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import awesome-->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">

</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contack</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Devcamp</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Huong NT</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Task 48
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="chartjs.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>ChartJS</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="quan_ly_bang_diem.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Quản lý bảng điểm</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <section class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1>Quản lý bảng điểm</h1>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Quản lý bảng điểm</li>
              </ol>
            </div>
          </div>
        </div><!-- /.container-fluid -->
      </section>

      <!-- Main content -->
      <section class="content">
        <!-- Vùng header -->
        <div class="container p-3">
          <div class="row">
            <div class="col-sm-12 text-center">
              <h3> LỊCH SỬ HỌC TẬP</h3>
            </div>
          </div>
          <div class="row form-group py-3 bg-light rounded">
            <label class="col-sm-2 col-form-label text-center"><b>Student</b></label>
            <div class="col-sm-3">
              <select id="select-student" class="form-control">
                <option value="0">--Select Student--</option>
              </select>
            </div>
            <label class="col-sm-2 col-form-label text-center"><b>Subject</b></label>
            <div class="col-sm-3">
              <select id="select-subject" class="form-control">
                <option value="0">--Select Subject--</option>
              </select>
            </div>
            <div class="col-sm-2">
              <button id="btn-filter" class="btn btn-success w-100">Filter Data</button>
            </div>
          </div>
          <hr>
          <div class="form-group">
            <button class="btn btn-success" id="btn-add-grade"><i class="fa fa-plus"></i>&nbsp; New Grade</button>
          </div>
          <div class="row form-group">
            <div class="col-sm-12">
              <table id="table-grade" class="table table-bordered table-striped table-hover">
                <thead class="thead-dark">
                  <tr>
                    <th>No.</th>
                    <th>Student</th>
                    <th>Subject</th>
                    <th>Grade</th>
                    <th>Exam Date</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>

                </tbody>
              </table>
            </div>
          </div>
        </div>
        <!-- Vùng Modal -->

        <!-- Create course modal -->
        <div>
          <div id="create-grade-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Create New Course</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <form>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="select-student">Student</label>
                      </div>
                      <div class="col-sm-9">
                        <select id="input-select-student" class="form-control">
                          <option value="0">--Select Student--</option>
                        </select>
                      </div>

                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="input-select-subject">Subject</label>
                      </div>

                      <div class="col-sm-9">
                        <select id="input-select-subject" class="form-control">
                          <option value="0">--Select Subject--</option>
                        </select>
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="create-input-grade">Grade</label>
                      </div>
                      <div class="col-sm-9">
                        <input type="number" id="create-input-grade" name="grade" placeholder="grade"
                          class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="create-input-exam-date">Exam date</label>
                      </div>
                      <div class="col-sm-9">
                        <input type="date" id="create-input-exam-date" name="create-input-exam-date"
                          placeholder="dd/yy/mm" class="form-control">
                      </div>
                    </div>
                  </form>
                </div>
                <div class="modal-footer">
                  <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                  <button class="btn btn-primary" id="btn-create-grade">Create</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- Update course modal -->
        <div>
          <div id="update-grade-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Update Course</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <form>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="select-student">Student</label>
                      </div>
                      <div class="col-sm-9">
                        <input type="number" id="update-input-student" name="grade" placeholder="grade"
                          class="form-control" disabled>
                      </div>

                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="update-select-subject">Subject</label>
                      </div>

                      <div class="col-sm-9">
                        <input type="number" id="update-input-subject" name="grade" placeholder="grade"
                          class="form-control" disabled>
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="update-input-grade">Grade</label>
                      </div>
                      <div class="col-sm-9">
                        <input type="number" id="update-input-grade" name="grade" placeholder="grade"
                          class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label for="update-input-exam-date">Exam date</label>
                      </div>
                      <div class="col-sm-9">
                        <input type="text" id="update-input-exam-date" name="update-input-exam-date"
                          placeholder="dd/yy/mm" class="form-control">
                      </div>
                    </div>
                  </form>
                </div>
                <div class="modal-footer">
                  <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                  <button class="btn btn-primary" id="btn-update-grade">Update</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- Delete confirm modal -->
        <div>
          <div id="delete-grade-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Delete information</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <label>Are you sure to delete this Grade?</label>
                </div>
                <div class="modal-footer">
                  <button class="btn btn-danger" id="btn-delete-grade">Delete</button>
                  <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>

      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gStudents = [];
  var gSubjects = [];
  var gGrades = [];
  var gGradeID = 0;

  var gSTT = 1;
  var gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
  var gCONTENT_TYPE = "application/json;charset=UTF-8";
  var gGradeInfoObj = {
    studentId: "",
    subjectId: "",
    grade: 0,
    examDate: "",
  };


  const gTABLE_ROW = ["id", "studentId", "subjectId", "grade", "examDate", "action"];
  const gSTT_COL = 0;
  const gSTUDENT_COL = 1;
  const gSUBJECT_COL = 2;
  const gGRADE_COL = 3;
  const gEXAM_DATE_COL = 4;
  const gACTION_COL = 5;

  var gTableGrade = $("#table-grade").DataTable({
    columns: [
      { data: gTABLE_ROW[gSTT_COL] },
      { data: gTABLE_ROW[gSTUDENT_COL] },
      { data: gTABLE_ROW[gSUBJECT_COL] },
      { data: gTABLE_ROW[gGRADE_COL] },
      { data: gTABLE_ROW[gEXAM_DATE_COL] },
      { data: gTABLE_ROW[gACTION_COL] },
    ],
    columnDefs: [
      {
        targets: gSTT_COL,
        render: function () {
          return gSTT++;
        }
      },
      {
        targets: gSTUDENT_COL,
        render: getStudentNameByStudentId
      },
      {
        targets: gSUBJECT_COL,
        render: getSubjectNameBySubjectId
      },
      {
        targets: gACTION_COL,
        className: "text-center",
        //tạo nội dung HTML là một
        defaultContent: `
                            <button id= "edit-grade"  <i title = 'Edit' class="fa-regular fa-pen-to-square" style = "cursor:pointer;"></i></button> &nbsp; 
                            <button id= "delete-grade" <i title = 'Delete' class="fa-solid fa-trash" style = "cursor:pointer;"></i></button>`,
      }
    ]
  })


  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
    // gán sự kiện click button Filter Data
    $(document).on("click", "#btn-filter", onBtnFilterClick);
    // 2 - C: gán sự kiện Create - Thêm mới grade
    $("#btn-add-grade").on("click", function () {
      onBtnAddNewGradeClick();
    });
    // gán sự kiện cho nút Create grade(trên modal)
    $("#create-grade-modal").on("click", "#btn-create-grade", function () {
      onBtnCreateGradeClick(this);
    });
    // 3 - U: gán sự kiện Update - khi nhấn nút edit
    $("#table-grade").on("click", "#edit-grade", function () {
      onBtnEditGradeClick(this)
    });
    //gán sự kiện cho các nút trên update grade modal
    $("#btn-update-grade").on("click", function () {
      onBtnUpdateGradeClick(this);
    });
    // 4 - D: gán sự kiện Delete
    $("#table-grade").on("click", "#delete-grade", function () {
      onBtnDeleteGradeClick(this)
    });
    //gán sự kiện cho các nút trên update grade modal
    $("#btn-delete-grade").on("click", function () {
      onBtnConfirmDeleteGradeClick(this);
    });


  });


  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // function xử lý sự kiện tải trang/F5
  function onPageLoading() {
    gGrades = callAPIGetAllGrades();
    gStudents = getAllStudent();
    console.log("get được: " + gStudents);
    gSubjects = getAllSubject();
    loadStudentDataToSelect();
    loadSubjectDataToSelect();

  }


  // function xử lý sự kiện click button Filter Data
  function onBtnFilterClick() {
    // khai báo đối tượng chứa dữ liệu
    let vFilterData = {
      studentId: "",
      subjectId: ""
    };
    // B1: Thu thập dữ liệu
    getFilterData(vFilterData);
    debugger;
    // B2: Kiểm tra dữ liệu
    let vDataValid = checkFilterData(vFilterData);
    if (vDataValid) {
      // B3: Xử lý hiển thị
      let vFilteredObject = findStudentByFilter(vFilterData);
      var vTable = $("#table-grade"); //truy vấn đến bảng có id = table-users
      vTable.find("tr:gt(0)").html(''); //xóa trắng bảng (k xóa header)
      if (vFilteredObject.length > 0) {
        //hiện thông báo đã tìm được
        alert("Tìm thấy " + vFilteredObject.length + " kết quả phù hợp");
        //hiển thị danh sách dữ liệu tìm được ra table
        showDataToTable(vFilteredObject);
      }
      else {
        alert("Không tìm thấy kết quả phù hợp");
        return false;
      }

    }
  }

  // hàm gọi ra khi nhấn button add new grade
  function onBtnAddNewGradeClick() {
    // hiển thị modal trắng lên
    $("#create-grade-modal").modal("show");
    loadStudentDataToSelect();
    loadSubjectDataToSelect();
  }

  //hàm gọi ra khi nhấn button create course
  function onBtnCreateGradeClick() {
    debugger;
    console.log("button create click")
    // khai báo đối tượng chứa voucher 
    // B1: Thu thập dữ liệu
    getCreateGradeData(gGradeInfoObj);
    console.log("thu thập thành công: Ngày thi: " + gGradeInfoObj.examDate + " , Điểm: " + gGradeInfoObj.grade)
    // B2: Validate insert
    var vIsValidate = validateGradeData(gGradeInfoObj);
    if (vIsValidate) {
      // B3: insert voucher
      $.ajax({
        url: gBASE_URL + "/grades",
        type: "POST",
        contentType: gCONTENT_TYPE,
        data: JSON.stringify(gGradeInfoObj),
        success: function (paramRes) {
          // B4: xử lý front-end
          handleInsertGradeSuccess()
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }

  }

  // Hàm xử lý sự kiện khi icon edit trên bảng đc click
  function onBtnEditGradeClick(paramBtnEdit) {
    console.log("Button edit được click")
    // lưu thông tin voucherId đang được edit vào biến toàn cục
    gGradeID = getGradeIdFromButton(paramBtnEdit);
    // load dữ liệu vào các trường dữ liệu trong modal
    console.log("ID lấy được (update): " + gGradeID)
    getGradeById(gGradeID);
  }

  //hàm xử lý sự kiện nhấn nút update user trên modal
  function onBtnUpdateGradeClick() {
    //khai báo đối tượng grade obj
    var vObjectRequestData = {
      studentId: "",
      subjectId: "",
      grade: "",
      examDate: ""
    }
    //b1: thu thập dữ liệu input trên modal
    getEditedGradeData(vObjectRequestData);
    //b2: validate
    var vIsValid = validateGradeUpdateData(vObjectRequestData);
    //b3: gọi API thêm user
    if (vIsValid) {
      callAPIToUpdateGrade(vObjectRequestData);
    };
  }


  //hàm xử lý sự kiện ấn icon delete 
  function onBtnDeleteGradeClick(paramBtnDelete) {
    $("#delete-grade-modal").modal("show");
    //lưu thông tin grade id vào biến toàn cục
    gGradeID = getGradeIdFromButton(paramBtnDelete);
    console.log("Id lấy được (delete): " + gGradeID);
  }

  //hàm xử lý sự kiện xác nhận xóa user
  function onBtnConfirmDeleteGradeClick() {
    "use strict";
    //gọi API xóa user
    callAPIToDeleteGrade(gGradeID);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm render số thứ tư
  function renderStt() {
    gStt++;
    return gStt;
  }
  //hàm render Student Name theo student id
  function renderStudentIdToStudentName(paramStudentId) {
    "use strict";
    var vStudentName = "NO_NAME";
    var vFound = false;
    var vViTriHienTai = 0;
    while (!vFound && vViTriHienTai < gStudentList.length) {
      if (gStudentList[vViTriHienTai].id.toString() === paramStudentId.toString()) {
        vStudentName = gStudentList[vViTriHienTai].lastname + " " + gStudentList[vViTriHienTai].firstname;
        vFound = true;
      }
      vViTriHienTai++;
    }
    return vStudentName;
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //function gọi API lấy toàn bộ điểm
  function callAPIGetAllGrades() {
    "use strict";
    $.ajax({
      url: gBASE_URL + "/grades",
      type: "GET",
      dataType: "json", // added data type
      success: function (res) {
        gGrades = res;
        showDataToTable(res);
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText)
      }
    });
    return gGrades;
  }

  // function gán data cho Table
  function showDataToTable(paramData) {
    gSTT = 1;
    gTableGrade.clear();
    gTableGrade.rows.add(paramData);
    gTableGrade.draw();
  }

  // function all students từ API
  function getAllStudent() {
    "use strict";
    $.ajax({
      url: gBASE_URL + "/students",
      type: "GET",
      async: false,
      dataType: "json", // added data type
      success: function (res) {
        console.log(res);
        gStudents = res
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText)
      }
    });
    return gStudents;
  }

  // function lấy tên Student theo studentId
  function getStudentNameByStudentId(paramStudentId) {
    "use strict";
    let vIndex = 0;
    let vFound = false;
    let vStudentName = "";
    while (!vFound && vIndex < gStudents.length) {
      if (gStudents[vIndex].id == paramStudentId) {
        vStudentName = gStudents[vIndex].firstname + " " + gStudents[vIndex].lastname;
        vFound = true;
      }
      vIndex++;
    }
    return vStudentName;
  }

  //function get all subject
  function getAllSubject() {
    "use strict";
    $.ajax({
      url: gBASE_URL + "/subjects",
      type: "GET",
      async: false,
      dataType: "json", // added data type
      success: function (res) {
        console.log(res);
        gSubjects = res
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText)
      }
    });
    return gSubjects;
  }

  // function lấy tên Subject theo Subject ID
  function getSubjectNameBySubjectId(paramSubjectId) {
    let vIndex = 0;
    let vFound = false;
    let vSubjectName = "";
    while (!vFound && vIndex < gSubjects.length) {
      if (gSubjects[vIndex].id == paramSubjectId) {
        vSubjectName = gSubjects[vIndex].subjectName;
        vFound = true;
      }
      vIndex++;
    }
    return vSubjectName;
  }


  // function thu thập dữ liệu filter data trên form
  // function return đối tượng paramFilterData được tham số hóa
  function getFilterData(paramFilterData) {
    paramFilterData.studentId = $("#select-student").val();
    paramFilterData.subjectId = $("#select-subject").val();
  }

  // function kiểm tra dữ liệu
  function checkFilterData(paramFilterData) {
    if (paramFilterData.studentId == "0" && paramFilterData.subjectId == "0") {
      alert("Please select Student or Subject to filter data");
      return false;
    }
    return true;
  }


  function findStudentByFilter(paramKeyWordObj) {
    "use strict";
    const bArrResultObj = [];
    debugger;
    //kiểm tra truồng hợp nếu StudentID và SubjectID được nhập
    if (paramKeyWordObj.studentId != "0" && paramKeyWordObj.subjectId != "0") {
      for (let bI = 0; bI < gGrades.length; bI++) {
        const bIStudentObj = gGrades[bI];
        //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
        if (paramKeyWordObj.studentId === bIStudentObj.studentId && paramKeyWordObj.subjectId === bIStudentObj.subjectId) {
          //thêm đối tượng thỏa mãn điều kiện vào array
          bArrResultObj.push(bIStudentObj);
        }
      }
    }

    //kiểm tra trường hợp nếu StudentID hoặc SubjectID được nhập
    else if (paramKeyWordObj.studentId != "0" || paramKeyWordObj.subjectId != "") {
      for (let bI = 0; bI < gGrades.length; bI++) {
        const bIStudentObj = gGrades[bI];
        //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
        if (paramKeyWordObj.studentId === bIStudentObj.studentId ||
          paramKeyWordObj.subjectId === bIStudentObj.subjectId) {
          //thêm đối tượng thỏa mãn điều kiện vào array
          bArrResultObj.push(bIStudentObj);
        }
      }
    }

    return bArrResultObj;
  }



  // hàm thu thập dữ liệu để create grades
  function getCreateGradeData(paramGradeObj) {
    paramGradeObj.studentId = $("#input-select-student").val();
    paramGradeObj.subjectId = $("#input-select-subject").val();
    paramGradeObj.grade = $("#create-input-grade").val();
    var inputDate = $("#create-input-exam-date").val();
    paramGradeObj.examDate = dateFormat(inputDate, "dd/MM/yyyy")

  }

  //hàm đọc thông tin grade data được edit
  function getEditedGradeData(paramGradeObj) {
    paramGradeObj.studentId = $("#update-input-student").val();
    paramGradeObj.subjectId = $("#update-input-subject").val();
    paramGradeObj.grade = $("#update-input-grade").val();
    paramGradeObj.examDate = $("#update-input-exam-date").val();
  }

  //API update grade
  function callAPIToUpdateGrade(paramGradeObj) {
    "use strict";
    $.ajax({
      url: gBASE_URL + "/grades/" + gGradeID,
      type: "PUT",
      contentType: gCONTENT_TYPE,
      data: JSON.stringify(paramGradeObj),
      success: function (paramRes) {
        console.log(paramRes);
        //b4: xử lý hiển thị
        handleUpdateGradeSuccess();
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
  }

  // hàm xử lý sự kiện confirm delete
  function callAPIToDeleteGrade() {
    $.ajax({
      url: gBASE_URL + "/grades/" + gGradeID,
      type: "DELETE",
      success: function (paramRes) {
        handleDeleteGradeSuccess();
      },
      error: function (paramErr) {
        alert("Can not delete this user");
        $("#delete-confirm-modal").modal("hide");
      }
    });
    // b4: xử lý hiển thị front-end
  }



  // hàm validate data
  function validateGradeData(paramGradeObj) {
    if (paramGradeObj.studentId == 0) {
      alert("Please select Student");
      return false;
    }
    if (paramGradeObj.subjectId == 0) {
      alert("Please select Subject");
      return false;
    }
    if (paramGradeObj.grade === "") {
      alert("Please input Grade");
      return false;
    }

    if (paramGradeObj.grade < 0 || paramGradeObj.price > 10) {
      alert("Grade must be between 0 and 10");
      return false;
    }

    if (paramGradeObj.examDate === "NaN-NaN-NaN") {
      alert("Please input Exam Date");
      return false;
    }

    return true;
  }

  // hàm validate data
  function validateGradeUpdateData(paramGradeObj) {
    if (paramGradeObj.grade === "") {
      alert("Please input Grade");
      return false;
    }

    if (paramGradeObj.examDate === "") {
      alert("Please input Exam Date");
      return false;
    }

    return true;
  }



  //hàm format lại Date theo dạng dd-mm-yyyy
  function dateFormat(inputDate, format) {
    //parse the input date
    const date = new Date(inputDate);

    //extract the parts of the date
    const day = date.getDate();
    const month = date.getMonth() + 1;
    const year = date.getFullYear();

    //replace the month
    format = format.replace("MM", month.toString().padStart(2, "0"));

    //replace the year
    if (format.indexOf("yyyy") > -1) {
      format = format.replace("yyyy", year.toString());
    } else if (format.indexOf("yy") > -1) {
      format = format.replace("yy", year.toString().substr(2, 2));
    }

    //replace the day
    format = format.replace("dd", day.toString().padStart(2, "0"));

    return format;
  }


  // hàm dựa vào button detail (edit or delete) xác định đc id 
  function getGradeIdFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vGradeRowData = gTableGrade.row(vTableRow).data();
    return vGradeRowData.id;
  }

  // hàm get voucher by id
  function getGradeById(paramGradeId) {
    $.ajax({
      url: gBASE_URL + "/grades/" + paramGradeId,
      type: "GET",
      success: function (paramGradeRes) {
        showGradeDataToModal(paramGradeRes);
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
    // hiển thị modal lên
    $("#update-grade-modal").modal("show");
  }
  // hàm show grade obj lên modal
  function showGradeDataToModal(paramGradeObj) {
    //var vStudentID = paramGradeObj.studentId;
    //var vStudentName = getStudentNameByStudentId(vStudentID);
    //console.log("Tên: " + vStudentName);
    //$("#update-input-student").val(vStudentName);
    //var vSubjectName = getSubjectNameBySubjectId(paramGradeObj.subjectId)
    $("#update-input-subject").val(paramGradeObj.subjectId);
    $("#update-input-student").val(paramGradeObj.studentId);
    $("#update-input-grade").val(paramGradeObj.grade);
    $("#update-input-exam-date").val(paramGradeObj.examDate);
  }

  // hàm xử lý hiển thị front-end khi thêm grade thành công
  function handleInsertGradeSuccess() {
    alert("Added Grade Successfully!");
    callAPIGetAllGrades();
    resertCreateGradeForm();
    $("#create-grade-modal").modal("hide");
  }

  // hàm xử lý hiển thị front-end khi update grade thành công
  function handleUpdateGradeSuccess() {
    alert("Update Grade Successfully!");
    callAPIGetAllGrades();
    //resertCreateGradeForm();
    $("#update-grade-modal").modal("hide");
  }

  //hàm xử lý khi delete thành công
  function handleDeleteGradeSuccess() {
    alert("Deleted grade successfully!");
    callAPIGetAllGrades();
    $("#delete-grade-modal").modal("hide");
  }

  // hàm xóa trắng form create grade
  function resertCreateGradeForm() {
    $("#input-select-student").val("");
    $("#input-select-subject").val("");
    $("#create-input-grade").val("");
    $("#create-input-exam-date").val("");
  }


  // function load student data vào select
  function loadStudentDataToSelect() {
    for (let bStudent of gStudents) {
      $("#select-student").append(
        $("<option>")
          .val(bStudent.id)
          .text(bStudent.firstname + " " + bStudent.lastname)
      );
    }
    for (let bStudent of gStudents) {
      $("#input-select-student").append(
        $("<option>")
          .val(bStudent.id)
          .text(bStudent.firstname + " " + bStudent.lastname)
      );
    }
  }

  // function load subject data vào select
  function loadSubjectDataToSelect() {
    for (let bSubject of gSubjects) {
      $("#select-subject").append(
        $("<option>")
          .val(bSubject.id)
          .text(bSubject.subjectName)
      );
    }
    for (let bSubject of gSubjects) {
      $("#input-select-subject").append(
        $("<option>")
          .val(bSubject.id)
          .text(bSubject.subjectName)
      );
    }
  }

</script>

</html>